(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ReduxDeepDiff"] = factory();
	else
		root["ReduxDeepDiff"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 5);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var UNDO = exports.UNDO = '@@redux-deep-diff/UNDO';
var REDO = exports.REDO = '@@redux-deep-diff/REDO';
var JUMP = exports.JUMP = '@@redux-deep-diff/JUMP';

var undo = exports.undo = function undo() {
  return { type: UNDO };
};
var redo = exports.redo = function redo() {
  return { type: REDO };
};
var jump = exports.jump = function jump(index) {
  return { type: JUMP, index: index };
};

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Module dependenices
 */

var isObject = __webpack_require__(8);
var clone = __webpack_require__(10);
var typeOf = __webpack_require__(14);
var forOwn = __webpack_require__(15);

/**
 * Recursively clone native types.
 */

function cloneDeep(val, instanceClone) {
  switch (typeOf(val)) {
    case 'object':
      return cloneObjectDeep(val, instanceClone);
    case 'array':
      return cloneArrayDeep(val, instanceClone);
    default: {
      return clone(val);
    }
  }
}

function cloneObjectDeep(obj, instanceClone) {
  if (isObject(obj)) {
    var res = {};
    forOwn(obj, function(obj, key) {
      this[key] = cloneDeep(obj, instanceClone);
    }, res);
    return res;
  } else if (instanceClone) {
    return instanceClone(obj);
  } else {
    return obj;
  }
}

function cloneArrayDeep(arr, instanceClone) {
  var len = arr.length, res = [];
  var i = -1;
  while (++i < len) {
    res[i] = cloneDeep(arr[i], instanceClone);
  }
  return res;
}

/**
 * Expose `cloneDeep`
 */

module.exports = cloneDeep;


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * is-extendable <https://github.com/jonschlinkert/is-extendable>
 *
 * Copyright (c) 2015, Jon Schlinkert.
 * Licensed under the MIT License.
 */



module.exports = function isExtendable(val) {
  return typeof val !== 'undefined' && val !== null
    && (typeof val === 'object' || typeof val === 'function');
};


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.revertDiffs = exports.revertChanges = exports.applyDiffs = exports.applyChanges = undefined;

var _deepDiff = __webpack_require__(4);

/**
 * Calls `applyChange` or `revertChange` on the target object for
 * each change
 * @param {Function} applyOrRevertChange - `applyChange` or `revertChange`
 * @param {Object} target - target object to apply changes to
 * @param {[Object]} changes - array of `deep-diff` change objects
 * @returns {Object} the given target
 */
function doChanges(applyOrRevertChange, target) {
  var changes = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  for (var i = 0, l = changes.length; i < l; i++) {
    // second argument to applyChange/revertChange is unused
    applyOrRevertChange(target, target, changes[i]);
  }

  return target;
}

/**
 * Calls `applyChange` or `revertChange` on the target object for
 * each change in each diff
 * @param {Function} applyOrRevertChange - `applyChange` or `revertChange`
 * @param {Object} target - target object to apply changes to
 * @param {[Array]} changes - array of diffs each containing
 * `deep-diff` change objects
 * @returns {Object} the given target
 */
function doDiffs(applyOrRevertChange, target) {
  var diffs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

  for (var i = 0, l = diffs.length; i < l; i++) {
    doChanges(applyOrRevertChange, target, diffs[i]);
  }

  return target;
}

// bind `applyChange` and `revertChange` to the functions above
var applyChanges = exports.applyChanges = doChanges.bind(null, _deepDiff.applyChange);
var applyDiffs = exports.applyDiffs = doDiffs.bind(null, _deepDiff.applyChange);
var revertChanges = exports.revertChanges = doChanges.bind(null, _deepDiff.revertChange);
var revertDiffs = exports.revertDiffs = doDiffs.bind(null, _deepDiff.revertChange);

/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* WEBPACK VAR INJECTION */(function(global) {
var $scope, conflict, conflictResolution = [];
if (typeof global === 'object' && global) {
  $scope = global;
} else if (typeof window !== 'undefined') {
  $scope = window;
} else {
  $scope = {};
}
conflict = $scope.DeepDiff;
if (conflict) {
  conflictResolution.push(
    function() {
      if ('undefined' !== typeof conflict && $scope.DeepDiff === accumulateDiff) {
        $scope.DeepDiff = conflict;
        conflict = undefined;
      }
    });
}

// nodejs compatible on server side and in the browser.
function inherits(ctor, superCtor) {
  ctor.super_ = superCtor;
  ctor.prototype = Object.create(superCtor.prototype, {
    constructor: {
      value: ctor,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
}

function Diff(kind, path) {
  Object.defineProperty(this, 'kind', {
    value: kind,
    enumerable: true
  });
  if (path && path.length) {
    Object.defineProperty(this, 'path', {
      value: path,
      enumerable: true
    });
  }
}

function DiffEdit(path, origin, value) {
  DiffEdit.super_.call(this, 'E', path);
  Object.defineProperty(this, 'lhs', {
    value: origin,
    enumerable: true
  });
  Object.defineProperty(this, 'rhs', {
    value: value,
    enumerable: true
  });
}
inherits(DiffEdit, Diff);

function DiffNew(path, value) {
  DiffNew.super_.call(this, 'N', path);
  Object.defineProperty(this, 'rhs', {
    value: value,
    enumerable: true
  });
}
inherits(DiffNew, Diff);

function DiffDeleted(path, value) {
  DiffDeleted.super_.call(this, 'D', path);
  Object.defineProperty(this, 'lhs', {
    value: value,
    enumerable: true
  });
}
inherits(DiffDeleted, Diff);

function DiffArray(path, index, item) {
  DiffArray.super_.call(this, 'A', path);
  Object.defineProperty(this, 'index', {
    value: index,
    enumerable: true
  });
  Object.defineProperty(this, 'item', {
    value: item,
    enumerable: true
  });
}
inherits(DiffArray, Diff);

function arrayRemove(arr, from, to) {
  var rest = arr.slice((to || from) + 1 || arr.length);
  arr.length = from < 0 ? arr.length + from : from;
  arr.push.apply(arr, rest);
  return arr;
}

function realTypeOf(subject) {
  var type = typeof subject;
  if (type !== 'object') {
    return type;
  }

  if (subject === Math) {
    return 'math';
  } else if (subject === null) {
    return 'null';
  } else if (Array.isArray(subject)) {
    return 'array';
  } else if (Object.prototype.toString.call(subject) === '[object Date]') {
    return 'date';
  } else if (typeof subject.toString === 'function' && /^\/.*\//.test(subject.toString())) {
    return 'regexp';
  }
  return 'object';
}

function deepDiff(lhs, rhs, changes, prefilter, path, key, stack) {
  path = path || [];
  stack = stack || [];
  var currentPath = path.slice(0);
  if (typeof key !== 'undefined') {
    if (prefilter) {
      if (typeof(prefilter) === 'function' && prefilter(currentPath, key)) {
        return; } else if (typeof(prefilter) === 'object') {
        if (prefilter.prefilter && prefilter.prefilter(currentPath, key)) {
          return; }
        if (prefilter.normalize) {
          var alt = prefilter.normalize(currentPath, key, lhs, rhs);
          if (alt) {
            lhs = alt[0];
            rhs = alt[1];
          }
        }
      }
    }
    currentPath.push(key);
  }

  // Use string comparison for regexes
  if (realTypeOf(lhs) === 'regexp' && realTypeOf(rhs) === 'regexp') {
    lhs = lhs.toString();
    rhs = rhs.toString();
  }

  var ltype = typeof lhs;
  var rtype = typeof rhs;

  var ldefined = ltype !== 'undefined' || (stack && stack[stack.length - 1].lhs && stack[stack.length - 1].lhs.hasOwnProperty(key));
  var rdefined = rtype !== 'undefined' || (stack && stack[stack.length - 1].rhs && stack[stack.length - 1].rhs.hasOwnProperty(key));

  if (!ldefined && rdefined) {
    changes(new DiffNew(currentPath, rhs));
  } else if (!rdefined && ldefined) {
    changes(new DiffDeleted(currentPath, lhs));
  } else if (realTypeOf(lhs) !== realTypeOf(rhs)) {
    changes(new DiffEdit(currentPath, lhs, rhs));
  } else if (realTypeOf(lhs) === 'date' && (lhs - rhs) !== 0) {
    changes(new DiffEdit(currentPath, lhs, rhs));
  } else if (ltype === 'object' && lhs !== null && rhs !== null) {
    if (!stack.filter(function(x) {
        return x.lhs === lhs; }).length) {
      stack.push({ lhs: lhs, rhs: rhs });
      if (Array.isArray(lhs)) {
        var i, len = lhs.length;
        for (i = 0; i < lhs.length; i++) {
          if (i >= rhs.length) {
            changes(new DiffArray(currentPath, i, new DiffDeleted(undefined, lhs[i])));
          } else {
            deepDiff(lhs[i], rhs[i], changes, prefilter, currentPath, i, stack);
          }
        }
        while (i < rhs.length) {
          changes(new DiffArray(currentPath, i, new DiffNew(undefined, rhs[i++])));
        }
      } else {
        var akeys = Object.keys(lhs);
        var pkeys = Object.keys(rhs);
        akeys.forEach(function(k, i) {
          var other = pkeys.indexOf(k);
          if (other >= 0) {
            deepDiff(lhs[k], rhs[k], changes, prefilter, currentPath, k, stack);
            pkeys = arrayRemove(pkeys, other);
          } else {
            deepDiff(lhs[k], undefined, changes, prefilter, currentPath, k, stack);
          }
        });
        pkeys.forEach(function(k) {
          deepDiff(undefined, rhs[k], changes, prefilter, currentPath, k, stack);
        });
      }
      stack.length = stack.length - 1;
    } else if (lhs !== rhs) {
      // lhs is contains a cycle at this element and it differs from rhs
      changes(new DiffEdit(currentPath, lhs, rhs));
    }
  } else if (lhs !== rhs) {
    if (!(ltype === 'number' && isNaN(lhs) && isNaN(rhs))) {
      changes(new DiffEdit(currentPath, lhs, rhs));
    }
  }
}

function accumulateDiff(lhs, rhs, prefilter, accum) {
  accum = accum || [];
  deepDiff(lhs, rhs,
    function(diff) {
      if (diff) {
        accum.push(diff);
      }
    },
    prefilter);
  return (accum.length) ? accum : undefined;
}

function applyArrayChange(arr, index, change) {
  if (change.path && change.path.length) {
    var it = arr[index],
      i, u = change.path.length - 1;
    for (i = 0; i < u; i++) {
      it = it[change.path[i]];
    }
    switch (change.kind) {
      case 'A':
        applyArrayChange(it[change.path[i]], change.index, change.item);
        break;
      case 'D':
        delete it[change.path[i]];
        break;
      case 'E':
      case 'N':
        it[change.path[i]] = change.rhs;
        break;
    }
  } else {
    switch (change.kind) {
      case 'A':
        applyArrayChange(arr[index], change.index, change.item);
        break;
      case 'D':
        arr = arrayRemove(arr, index);
        break;
      case 'E':
      case 'N':
        arr[index] = change.rhs;
        break;
    }
  }
  return arr;
}

function applyChange(target, source, change) {
  if (target && source && change && change.kind) {
    var it = target,
      i = -1,
      last = change.path ? change.path.length - 1 : 0;
    while (++i < last) {
      if (typeof it[change.path[i]] === 'undefined') {
        it[change.path[i]] = (typeof change.path[i] === 'number') ? [] : {};
      }
      it = it[change.path[i]];
    }
    switch (change.kind) {
      case 'A':
        applyArrayChange(change.path ? it[change.path[i]] : it, change.index, change.item);
        break;
      case 'D':
        delete it[change.path[i]];
        break;
      case 'E':
      case 'N':
        it[change.path[i]] = change.rhs;
        break;
    }
  }
}

function revertArrayChange(arr, index, change) {
  if (change.path && change.path.length) {
    // the structure of the object at the index has changed...
    var it = arr[index],
      i, u = change.path.length - 1;
    for (i = 0; i < u; i++) {
      it = it[change.path[i]];
    }
    switch (change.kind) {
      case 'A':
        revertArrayChange(it[change.path[i]], change.index, change.item);
        break;
      case 'D':
        it[change.path[i]] = change.lhs;
        break;
      case 'E':
        it[change.path[i]] = change.lhs;
        break;
      case 'N':
        delete it[change.path[i]];
        break;
    }
  } else {
    // the array item is different...
    switch (change.kind) {
      case 'A':
        revertArrayChange(arr[index], change.index, change.item);
        break;
      case 'D':
        arr[index] = change.lhs;
        break;
      case 'E':
        arr[index] = change.lhs;
        break;
      case 'N':
        arr = arrayRemove(arr, index);
        break;
    }
  }
  return arr;
}

function revertChange(target, source, change) {
  if (target && source && change && change.kind) {
    var it = target,
      i, u;
    u = change.path.length - 1;
    for (i = 0; i < u; i++) {
      if (typeof it[change.path[i]] === 'undefined') {
        it[change.path[i]] = {};
      }
      it = it[change.path[i]];
    }
    switch (change.kind) {
      case 'A':
        // Array was modified...
        // it will be an array...
        revertArrayChange(it[change.path[i]], change.index, change.item);
        break;
      case 'D':
        // Item was deleted...
        it[change.path[i]] = change.lhs;
        break;
      case 'E':
        // Item was edited...
        it[change.path[i]] = change.lhs;
        break;
      case 'N':
        // Item is new...
        delete it[change.path[i]];
        break;
    }
  }
}

function applyDiff(target, source, filter) {
  if (target && source) {
    var onChange = function(change) {
      if (!filter || filter(target, source, change)) {
        applyChange(target, source, change);
      }
    };
    deepDiff(target, source, onChange);
  }
}

Object.defineProperties(accumulateDiff, {

  diff: {
    value: accumulateDiff,
    enumerable: true
  },
  observableDiff: {
    value: deepDiff,
    enumerable: true
  },
  applyDiff: {
    value: applyDiff,
    enumerable: true
  },
  applyChange: {
    value: applyChange,
    enumerable: true
  },
  revertChange: {
    value: revertChange,
    enumerable: true
  },
  isConflict: {
    value: function() {
      return 'undefined' !== typeof conflict;
    },
    enumerable: true
  },
  noConflict: {
    value: function() {
      if (conflictResolution) {
        conflictResolution.forEach(function(it) {
          it();
        });
        conflictResolution = null;
      }
      return accumulateDiff;
    },
    enumerable: true
  }
});

/* harmony default export */ __webpack_exports__["default"] = (accumulateDiff);

/* WEBPACK VAR INJECTION */}.call(__webpack_exports__, __webpack_require__(17)))

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(6);


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _actions = __webpack_require__(0);

Object.keys(_actions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _actions[key];
    }
  });
});

var _deducer = __webpack_require__(7);

Object.defineProperty(exports, 'createDeducer', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_deducer).default;
  }
});

var _reducer = __webpack_require__(18);

Object.defineProperty(exports, 'default', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_reducer).default;
  }
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = createDeducer;

var _cloneDeep = __webpack_require__(1);

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _util = __webpack_require__(3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Creates a function which is then able to deduce the state history
 * from a state containing a diff leaf
 * @param {Function} selector - given the arguments provided to the
 * resulting deducer, should return a desired part of the state
 * @param {Object} config - configuration object
 * @returns {Function} the deducer function
 */
function createDeducer(selector) {
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _config$key = config.key,
      key = _config$key === undefined ? 'diff' : _config$key,
      _config$next = config.next,
      next = _config$next === undefined ? false : _config$next,
      _config$unique = config.unique,
      unique = _config$unique === undefined ? false : _config$unique,
      _config$index = config.index,
      index = _config$index === undefined ? false : _config$index,
      _config$range = config.range,
      range = _config$range === undefined ? false : _config$range,
      _config$limit = config.limit,
      limit = _config$limit === undefined ? false : _config$limit;


  if (index !== false && (range || limit) || range && limit) {
    console.warn('index, range, or limit should not be combined');
  }

  var makeChanges = next ? _util.applyChanges : _util.revertChanges;

  /**
   * Deduces the state history from a state containing a diff leaf.
   * Any additional arguments will be passed along to the `selector`
   * function
   * @param {Object} rawState - a state which contains a diff leaf
   * @returns {Array} an array containing the selected state history
   * @throws {Error} when the diff leaf cannot be found
   */
  var deducer = function deducer(rawState) {
    var history = rawState[key],
        state = _objectWithoutProperties(rawState, [key]);

    // ensure we don't modify state while dealing with changes


    state = (0, _cloneDeep2.default)(state);

    if (!history || !(history.prev && history.next)) {
      throw new Error('"' + key + '" is not a diff history object');
    }

    var diffs = next ? history.next : history.prev;

    // return from the cache if the diffs haven't changed
    if (deducer.cache.self) {
      var _deducer$cache$self = _slicedToArray(deducer.cache.self, 2),
          cached = _deducer$cache$self[0],
          result = _deducer$cache$self[1];

      if (diffs === cached) return result;
    }

    // normalize `range` and `limit` to lower and upper bounds
    var length = diffs.length;

    var _ref = range || [0, (limit || length) - 1],
        _ref2 = _slicedToArray(_ref, 2),
        lower = _ref2[0],
        upper = _ref2[1];
    // clamp the boundaries by the `index` or the diff length


    lower = index !== false ? index : Math.max(lower, 0);
    upper = index !== false ? index : Math.min(upper, length - 1);

    var deduced = [];

    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    for (var i = 0; i <= length; i++) {
      // make changes every time so previous/later states remain
      // accurate to the diff
      makeChanges(state, diffs[i]);

      // if we're outside the boundaries, don't do anything else
      if (i < lower || i > upper) continue;

      // initially load from the cache
      var cacheId = i - length;

      var _ref3 = deducer.cache[cacheId] || [],
          _ref4 = _slicedToArray(_ref3, 2),
          _cached = _ref4[0],
          _result = _ref4[1];

      // if the diff has changed, get the selected value and cache it


      if (!_cached || diffs[i] !== _cached) {
        _result = selector.apply(undefined, [state].concat(args));
        deducer.cache[cacheId] = [diffs[i], _result];
      }

      // skip results that follow each other
      if (unique) {
        var last = next ? deduced[deduced.length - 1] : deduced[0];
        if (_result === last) continue;
      }

      // push, unshift, or return the deduced result
      if (index === false) {
        if (next) {
          deduced.push(_result);
        } else {
          deduced.unshift(_result);
        }
      } else if (i === index) {
        return _result;
      }
    }

    // if the index never returned a result, we haven't deduced anything
    deduced = index === false ? deduced : null;
    // cache the deducers results
    deducer.cache.self = [diffs, deduced];
    return deduced;
  };

  deducer.cache = {};
  return deducer;
}

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * is-plain-object <https://github.com/jonschlinkert/is-plain-object>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */



var isObject = __webpack_require__(9);

function isObjectObject(o) {
  return isObject(o) === true
    && Object.prototype.toString.call(o) === '[object Object]';
}

module.exports = function isPlainObject(o) {
  var ctor,prot;

  if (isObjectObject(o) === false) return false;

  // If has modified constructor
  ctor = o.constructor;
  if (typeof ctor !== 'function') return false;

  // If has modified prototype
  prot = ctor.prototype;
  if (isObjectObject(prot) === false) return false;

  // If constructor does not have an Object-specific method
  if (prot.hasOwnProperty('isPrototypeOf') === false) {
    return false;
  }

  // Most likely a plain Object
  return true;
};


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * isobject <https://github.com/jonschlinkert/isobject>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */



module.exports = function isObject(val) {
  return val != null && typeof val === 'object' && Array.isArray(val) === false;
};


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * shallow-clone <https://github.com/jonschlinkert/shallow-clone>
 *
 * Copyright (c) 2015-2017, Jon Schlinkert.
 * Released under the MIT License.
 */



var isObject = __webpack_require__(2);
var mixin = __webpack_require__(11);
var typeOf = __webpack_require__(13);

/**
 * Shallow copy an object, array or primitive.
 *
 * @param  {any} `val`
 * @return {any}
 */

function clone(val) {
  var type = typeOf(val);
  if (clone.hasOwnProperty(type)) {
    return clone[type](val);
  }
  return val;
}

clone.array = function cloneArray(arr) {
  return arr.slice();
};

clone.date = function cloneDate(date) {
  return new Date(+date);
};

clone.object = function cloneObject(obj) {
  if (isObject(obj)) {
    return mixin({}, obj);
  } else {
    return obj;
  }
};

clone.regexp = function cloneRegExp(re) {
  var flags = '';
  flags += re.multiline ? 'm' : '';
  flags += re.global ? 'g' : '';
  flags += re.ignorecase ? 'i' : '';
  return new RegExp(re.source, flags);
};

/**
 * Expose `clone`
 */

module.exports = clone;


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var isObject = __webpack_require__(2);
var forIn = __webpack_require__(12);

function mixin(target, objects) {
  if (!isObject(target)) {
    throw new TypeError('mixin-object expects the first argument to be an object.');
  }
  var len = arguments.length, i = 0;
  while (++i < len) {
    var obj = arguments[i];
    if (isObject(obj)) {
      forIn(obj, copy, target);
    }
  }
  return target;
}

/**
 * copy properties from the source object to the
 * target object.
 *
 * @param  {*} `value`
 * @param  {String} `key`
 */

function copy(value, key) {
  this[key] = value;
}

/**
 * Expose `mixin`
 */

module.exports = mixin;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * for-in <https://github.com/jonschlinkert/for-in>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */



module.exports = function forIn(obj, fn, thisArg) {
  for (var key in obj) {
    if (fn.call(thisArg, obj[key], key, obj) === false) {
      break;
    }
  }
};


/***/ }),
/* 13 */
/***/ (function(module, exports) {

var toString = Object.prototype.toString;

/**
 * Get the native `typeof` a value.
 *
 * @param  {*} `val`
 * @return {*} Native javascript type
 */

module.exports = function kindOf(val) {
  var type = typeof val;

  // primitivies
  if (type === 'undefined') {
    return 'undefined';
  }
  if (val === null) {
    return 'null';
  }
  if (val === true || val === false || val instanceof Boolean) {
    return 'boolean';
  }
  if (type === 'string' || val instanceof String) {
    return 'string';
  }
  if (type === 'number' || val instanceof Number) {
    return 'number';
  }

  // functions
  if (type === 'function' || val instanceof Function) {
    if (typeof val.constructor.name !== 'undefined' && val.constructor.name.slice(0, 9) === 'Generator') {
      return 'generatorfunction';
    }
    return 'function';
  }

  // array
  if (typeof Array.isArray !== 'undefined' && Array.isArray(val)) {
    return 'array';
  }

  // check for instances of RegExp and Date before calling `toString`
  if (val instanceof RegExp) {
    return 'regexp';
  }
  if (val instanceof Date) {
    return 'date';
  }

  // other objects
  type = toString.call(val);

  if (type === '[object RegExp]') {
    return 'regexp';
  }
  if (type === '[object Date]') {
    return 'date';
  }
  if (type === '[object Arguments]') {
    return 'arguments';
  }
  if (type === '[object Error]') {
    return 'error';
  }
  if (type === '[object Promise]') {
    return 'promise';
  }

  // buffer
  if (isBuffer(val)) {
    return 'buffer';
  }

  // es6: Map, WeakMap, Set, WeakSet
  if (type === '[object Set]') {
    return 'set';
  }
  if (type === '[object WeakSet]') {
    return 'weakset';
  }
  if (type === '[object Map]') {
    return 'map';
  }
  if (type === '[object WeakMap]') {
    return 'weakmap';
  }
  if (type === '[object Symbol]') {
    return 'symbol';
  }
  if (type === '[object Map Iterator]') {
    return 'mapiterator';
  }
  if (type === '[object Set Iterator]') {
    return 'setiterator';
  }

  // typed arrays
  if (type === '[object Int8Array]') {
    return 'int8array';
  }
  if (type === '[object Uint8Array]') {
    return 'uint8array';
  }
  if (type === '[object Uint8ClampedArray]') {
    return 'uint8clampedarray';
  }
  if (type === '[object Int16Array]') {
    return 'int16array';
  }
  if (type === '[object Uint16Array]') {
    return 'uint16array';
  }
  if (type === '[object Int32Array]') {
    return 'int32array';
  }
  if (type === '[object Uint32Array]') {
    return 'uint32array';
  }
  if (type === '[object Float32Array]') {
    return 'float32array';
  }
  if (type === '[object Float64Array]') {
    return 'float64array';
  }

  // must be a plain object
  return 'object';
};

/**
 * If you need to support Safari 5-7 (8-10 yr-old browser),
 * take a look at https://github.com/feross/is-buffer
 */

function isBuffer(val) {
  return val.constructor
    && typeof val.constructor.isBuffer === 'function'
    && val.constructor.isBuffer(val);
}


/***/ }),
/* 14 */
/***/ (function(module, exports) {

var toString = Object.prototype.toString;

/**
 * Get the native `typeof` a value.
 *
 * @param  {*} `val`
 * @return {*} Native javascript type
 */

module.exports = function kindOf(val) {
  var type = typeof val;

  // primitivies
  if (type === 'undefined') {
    return 'undefined';
  }
  if (val === null) {
    return 'null';
  }
  if (val === true || val === false || val instanceof Boolean) {
    return 'boolean';
  }
  if (type === 'string' || val instanceof String) {
    return 'string';
  }
  if (type === 'number' || val instanceof Number) {
    return 'number';
  }

  // functions
  if (type === 'function' || val instanceof Function) {
    if (typeof val.constructor.name !== 'undefined' && val.constructor.name.slice(0, 9) === 'Generator') {
      return 'generatorfunction';
    }
    return 'function';
  }

  // array
  if (typeof Array.isArray !== 'undefined' && Array.isArray(val)) {
    return 'array';
  }

  // check for instances of RegExp and Date before calling `toString`
  if (val instanceof RegExp) {
    return 'regexp';
  }
  if (val instanceof Date) {
    return 'date';
  }

  // other objects
  type = toString.call(val);

  if (type === '[object RegExp]') {
    return 'regexp';
  }
  if (type === '[object Date]') {
    return 'date';
  }
  if (type === '[object Arguments]') {
    return 'arguments';
  }
  if (type === '[object Error]') {
    return 'error';
  }
  if (type === '[object Promise]') {
    return 'promise';
  }

  // buffer
  if (isBuffer(val)) {
    return 'buffer';
  }

  // es6: Map, WeakMap, Set, WeakSet
  if (type === '[object Set]') {
    return 'set';
  }
  if (type === '[object WeakSet]') {
    return 'weakset';
  }
  if (type === '[object Map]') {
    return 'map';
  }
  if (type === '[object WeakMap]') {
    return 'weakmap';
  }
  if (type === '[object Symbol]') {
    return 'symbol';
  }
  if (type === '[object Map Iterator]') {
    return 'mapiterator';
  }
  if (type === '[object Set Iterator]') {
    return 'setiterator';
  }

  // typed arrays
  if (type === '[object Int8Array]') {
    return 'int8array';
  }
  if (type === '[object Uint8Array]') {
    return 'uint8array';
  }
  if (type === '[object Uint8ClampedArray]') {
    return 'uint8clampedarray';
  }
  if (type === '[object Int16Array]') {
    return 'int16array';
  }
  if (type === '[object Uint16Array]') {
    return 'uint16array';
  }
  if (type === '[object Int32Array]') {
    return 'int32array';
  }
  if (type === '[object Uint32Array]') {
    return 'uint32array';
  }
  if (type === '[object Float32Array]') {
    return 'float32array';
  }
  if (type === '[object Float64Array]') {
    return 'float64array';
  }

  // must be a plain object
  return 'object';
};

/**
 * If you need to support Safari 5-7 (8-10 yr-old browser),
 * take a look at https://github.com/feross/is-buffer
 */

function isBuffer(val) {
  return val.constructor
    && typeof val.constructor.isBuffer === 'function'
    && val.constructor.isBuffer(val);
}


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * for-own <https://github.com/jonschlinkert/for-own>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */



var forIn = __webpack_require__(16);
var hasOwn = Object.prototype.hasOwnProperty;

module.exports = function forOwn(obj, fn, thisArg) {
  forIn(obj, function(val, key) {
    if (hasOwn.call(obj, key)) {
      return fn.call(thisArg, obj[key], key, obj);
    }
  });
};


/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * for-in <https://github.com/jonschlinkert/for-in>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */



module.exports = function forIn(obj, fn, thisArg) {
  for (var key in obj) {
    if (fn.call(thisArg, obj[key], key, obj) === false) {
      break;
    }
  }
};


/***/ }),
/* 17 */
/***/ (function(module, exports) {

var g;

// This works in non-strict mode
g = (function() {
	return this;
})();

try {
	// This works if eval is allowed (see CSP)
	g = g || Function("return this")() || (1,eval)("this");
} catch(e) {
	// This works if the window reference is available
	if(typeof window === "object")
		g = window;
}

// g can still be undefined, but nothing to do about it...
// We return undefined, instead of nothing here, so it's
// easier to handle this case. if(!global) { ...}

module.exports = g;


/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = diff;

var _cloneDeep = __webpack_require__(1);

var _cloneDeep2 = _interopRequireDefault(_cloneDeep);

var _accumulator = __webpack_require__(19);

var _accumulator2 = _interopRequireDefault(_accumulator);

var _actions = __webpack_require__(0);

var _util = __webpack_require__(3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/**
 * Immutably prepends a new diff to the history's previous diffs
 * @param {Object} history - diff history
 * @param {Array} addition - new diff
 * @returns {Object} new diff history object
 */
function addToHistory(history, addition) {
  return addition.length === 0 ? history : _extends({}, history, {
    prev: [addition].concat(_toConsumableArray(history.prev)).slice(0, history.limit || history.prev.length + 1),
    next: []
  });
}

/**
 * Immutably moves previous diff history to the next diff history, optionally by
 * an offset
 * @param {Object} history - diff history
 * @param {Number} offset - amount of diffs to move
 * @returns {Object} new diff history object
 */
function jumpToPrevHistory(history) {
  var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

  offset = Math.min(history.prev.length, offset);

  return _extends({}, history, {
    prev: history.prev.slice(offset),
    next: [].concat(_toConsumableArray(history.prev.slice(0, offset).reverse()), _toConsumableArray(history.next)).slice(0, history.limit || history.next.length + offset)
  });
}

/**
 * Immutably moves the next diff distory to the previous diff history,
 * optionally by an offset
 * @param {Object} history - diff history
 * @param {Number} offset - amount of diffs to move
 * @returns {Object} new diff history object
 */
function jumpToNextHistory(history) {
  var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

  offset = Math.min(history.next.length, offset);

  return _extends({}, history, {
    prev: [].concat(_toConsumableArray(history.next.slice(0, offset).reverse()), _toConsumableArray(history.prev)).slice(0, history.limit || history.prev.length + offset),
    next: history.next.slice(offset)
  });
}

/**
 * Higher order reducer to track deep-diff states before and after each
 * action. Additonally will undo or redo the state when specific actions are
 * dispatched.
 * @param {Function} reducer - redux reducer
 * @param {Object} config - configuration object
 * @returns {Function} reduc reducer with a diff history leaf
 */
function diff(reducer) {
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _config$key = config.key,
      key = _config$key === undefined ? 'diff' : _config$key,
      _config$limit = config.limit,
      limit = _config$limit === undefined ? 0 : _config$limit,
      _config$undoType = config.undoType,
      undoType = _config$undoType === undefined ? _actions.UNDO : _config$undoType,
      _config$redoType = config.redoType,
      redoType = _config$redoType === undefined ? _actions.REDO : _config$redoType,
      _config$jumpType = config.jumpType,
      jumpType = _config$jumpType === undefined ? _actions.JUMP : _config$jumpType,
      _config$skipAction = config.skipAction,
      skipAction = _config$skipAction === undefined ? function () {
    return false;
  } : _config$skipAction,
      _config$initialState = config.initialState,
      initialState = _config$initialState === undefined ? { prev: [], next: [] } : _config$initialState,
      _config$ignoreInit = config.ignoreInit,
      ignoreInit = _config$ignoreInit === undefined ? true : _config$ignoreInit,
      _config$flatten = config.flatten,
      flatten = _config$flatten === undefined ? function () {
    return false;
  } : _config$flatten,
      _config$prefilter = config.prefilter,
      prefilter = _config$prefilter === undefined ? function () {
    return false;
  } : _config$prefilter;

  // this will accumulate and merge diffs until `accum.clear()` is called

  var accum = new _accumulator2.default({ flatten: flatten, prefilter: prefilter });

  return function (rawState, action) {
    var _ref = rawState || {},
        history = _ref[key],
        state = _objectWithoutProperties(_ref, [key]);

    history = history || _extends({}, initialState, { limit: limit });

    var lhs = rawState && state;
    var rhs = reducer(lhs, action);
    var nextState = rhs || {};
    var changes = void 0,
        diffs = void 0;

    switch (action.type) {
      case undoType:
        nextState = (0, _util.revertChanges)((0, _cloneDeep2.default)(lhs), history.prev[0]);
        history = jumpToPrevHistory(history);
        break;

      case redoType:
        nextState = (0, _util.applyChanges)((0, _cloneDeep2.default)(lhs), history.next[0]);
        history = jumpToNextHistory(history);
        break;

      case jumpType:
        // apply a subset of previous diffs
        if (action.index < 0) {
          diffs = history.prev.slice(0, Math.abs(action.index));
          nextState = (0, _util.revertDiffs)((0, _cloneDeep2.default)(lhs), diffs);
          history = jumpToPrevHistory(history, Math.abs(action.index));

          // apply a subset of future diffs
        } else if (action.index > 0) {
          diffs = history.next.slice(0, Math.abs(action.index));
          nextState = (0, _util.applyDiffs)((0, _cloneDeep2.default)(lhs), diffs);
          history = jumpToNextHistory(history, action.index);
        }

        break;

      default:
        // when `rawState` is undefined, chances are this is the very first time
        // this reduce has been called. We ignore this initial call by default,
        // otherwise it will generate a diff for each leaf in the entire state.
        changes = rawState || !ignoreInit ? accum.diff(lhs, rhs) : [];

        if (!skipAction(action)) {
          history = addToHistory(history, changes);
          accum.clear();
        }
    }

    return _extends({}, nextState, _defineProperty({}, key, history));
  };
};

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _deepDiff = __webpack_require__(4);

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Returns true when two arrays of keys are equal
 * @param {[String]} actual - array of keys
 * @param {[String]} expected - array of expected keys
 * @returns {Boolean}
 */
function isPathsEqual(actual, expected) {
  return actual.length === expected.length && actual.every(function (k, i) {
    return k === expected[i];
  });
}

/**
 * Returns the value at the specified path in the target objecgt
 * @param {Object} target - target object
 * @param {[String]} path - array of nested keys
 * @returns {Mixed} value at the specified path
 */
function getSubjectAtPath(target, path) {
  return (typeof target === 'undefined' ? 'undefined' : _typeof(target)) !== 'object' ? null : path.reduce(function (value, key) {
    return typeof !value === 'undefined' ? value : value[key];
  }, target);
}

/**
 * Merges two `deep-diff` change objects as POJOs
 * @param {Object} a - first change to merge
 * @param {Object} b - second change to merge
 * @returns {Object} a new, merged change
 */
function mergeChanges(a, b) {
  // if an empty object is returned, there is no change
  var merged = {};

  // these changes would cancel out otherwise
  if (a.lhs !== b.rhs) {
    // arrays need their items merged
    if (a.kind === 'A' || b.kind === 'A') {
      var item = mergeChanges(a.kind === 'A' ? a.item : { kind: a.kind, lhs: a.lhs }, b.kind === 'A' ? b.item : { kind: b.kind, rhs: b.rhs });

      // items would cancel out otherwise
      if (item && item.kind) {
        // if `a` wasn't the array, `b` was
        merged = a.kind === 'A' ? _extends({}, a, { item: item }) : _extends({}, b, { item: item });
      }
      // if `b` was an edit and `a` was an addition, keep `a`
    } else if (a.kind !== 'D' && b.kind === 'E') {
      merged = _extends({}, a, { rhs: b.rhs });
      // if `a` was a delete and `b` isn't, it was an edit
    } else if (a.kind === 'D' && b.kind !== 'D') {
      merged = { kind: 'E', path: a.path, lhs: a.lhs, rhs: b.rhs };
      // if `a` wasn't a delete, but `b` was, keep `b`
    } else if (a.kind !== 'D' && b.kind === 'D') {
      merged = _extends({}, b, { lhs: a.lhs });
      // unhandled shouldn't be added to the diff
    } else {
      return;
    }
  }

  return merged;
}

/**
 * A diff accumulator is simply something that implements `.push()`
 *
 * This diff accumulator will flatten changes that match the `filter`
 * option. It will also automatically add those flattened changes to the
 * `prefilter` argument to prevent `deep-diff` from doing any further
 * analysis on the flattened object-property path.
 */

var DiffAccumulator = function () {

  /**
   * @constructor
   * @param {Function} flatten - matches changes that should be flattened
   * @param {Function} prefilter - matches changes that should not be analyzed
   */
  function DiffAccumulator() {
    var _this = this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        flatten = _ref.flatten,
        prefilter = _ref.prefilter;

    _classCallCheck(this, DiffAccumulator);

    this.flattened = [];
    this.changes = [];
    this.lhs = null;
    this.rhs = null;

    this.prefilter = function (path, key) {
      if (_this.isFlattened([].concat(_toConsumableArray(path), [key]))) {
        return true;
      } else if (_this.opts.prefilter) {
        return _this.opts.prefilter(path, key);
      } else {
        return false;
      }
    };

    this.opts = { flatten: flatten, prefilter: prefilter };
  }

  /**
   * Wrap the `prefilter` option to also filter flattened changes
   * @param {[String]} path - object-property path
   * @param {String} key - current key to filter
   * @returns {Boolean} `true` to filter, `false` otherwise
   */


  _createClass(DiffAccumulator, [{
    key: 'diff',


    /**
     * Calculates the structural difference between two object, passing
     * this instance as the accumulator
     * @param {Object} lhs - left hand side assignment
     * @param {Object} rhs - right hand side aassignment
     * @returns {Array} the accumulated changes
     */
    value: function diff(lhs, rhs) {
      this.flattened = [];
      this.lhs = lhs;
      this.rhs = rhs;

      (0, _deepDiff.diff)(lhs, rhs, this.prefilter, this);
      return this.changes;
    }

    /**
     * Clears the current accumulated diffs
     */

  }, {
    key: 'clear',
    value: function clear() {
      this.changes = [];
    }

    /**
     * If the path of the change should be flattened, this method
     * returns the flattened path
     * @param {Object} change - `deep-diff` change object
     * @returns {[String]} the path of the flattened change
     */

  }, {
    key: 'getFlatPath',
    value: function getFlatPath(change) {
      var _this2 = this;

      var index = -1;

      if (this.opts.flatten) {
        index = change.path.findIndex(function (key, i, path) {
          return _this2.opts.flatten(path.slice(0, i), key);
        });
      }

      return index >= 0 ? change.path.slice(0, index + 1) : change.path;
    }

    /**
     * Returns `true` if the path or any parent path was flattened,
     * 'false' otherwise
     * @param {[String]} path - path to check
     * @returns {Boolean} `true` if any parent path was flattend
     */

  }, {
    key: 'isFlattened',
    value: function isFlattened(path) {
      return this.flattened.some(function (done) {
        return isPathsEqual(done, path);
      });
    }

    /**
     * Pushes a POJO change to the diff array, maybe merging previous changes
     * @param {Object} change - `deep-diff` change object
     */

  }, {
    key: 'addChange',
    value: function addChange(change) {
      var existingIndex = this.changes.findIndex(function (c) {
        // array paths should include the index when comparing across changes
        var pathA = change.kind === 'A' ? [].concat(_toConsumableArray(change.path), [change.index]) : change.path;
        var pathB = c.kind === 'A' ? [].concat(_toConsumableArray(c.path), [c.index]) : c.path;
        return isPathsEqual(pathA, pathB);
      });

      // ensure change is a POJO
      if (change.item) {
        change = _extends({}, change, { item: _extends({}, change.item) });
      } else {
        change = _extends({}, change);
      }

      // merge existing changes
      if (existingIndex > -1) {
        var merged = mergeChanges(this.changes[existingIndex], change);

        // remove the change if `merged` is empty
        if (merged && !merged.kind) {
          this.changes.splice(existingIndex, 1);
        } else if (merged) {
          this.changes.splice(existingIndex, 1, merged);
        }
      } else {
        this.changes.push(change);
      }
    }

    /**
     * Handles how changes are pushed to the diff. Will push flattened
     * changes when neccesary
     * @param {Object} change - `deep-diff` change object
     */

  }, {
    key: 'push',
    value: function push(change) {
      var flatPath = this.getFlatPath(change);
      if (this.isFlattened(flatPath)) return;

      // flatten non-array changes when the change path is deeper than
      // the potentially flattened path
      if (change.kind !== 'A' && !isPathsEqual(flatPath, change.path)) {
        var lhs = getSubjectAtPath(this.lhs, flatPath);
        var rhs = getSubjectAtPath(this.rhs, flatPath);
        this.addChange({ kind: 'E', path: flatPath, lhs: lhs, rhs: rhs });
        this.flattened.push(flatPath);
      } else {
        this.addChange(change);
      }
    }
  }]);

  return DiffAccumulator;
}();

exports.default = DiffAccumulator;

/***/ })
/******/ ]);
});